%define anolis_release 3

Name:    parted
Version: 3.5
Release: %{anolis_release}%{?dist}
Summary: The GNU disk partition manipulation program
License: GPLv3+
URL:     http://www.gnu.org/software/parted

Source0: https://ftp.gnu.org/gnu/%{name}/%{name}-%{version}.tar.xz

Patch1: 0001-maint-post-release-administrivia.patch
Patch2: 0002-parted-add-type-command.patch
Patch3: 0003-libparted-add-swap-flag-for-DASD-label.patch
Patch4: 0004-parted-Reset-the-filesystem-type-when-changing-the-i.patch
Patch5: 0005-tests-t3200-type-change-now-passes.patch
Patch6: 0006-libparted-Fix-check-for-availability-of-_type_id-fun.patch
Patch7: 0007-parted-Simplify-code-for-json-output.patch
Patch8: 0008-disk.in.h-Remove-use-of-enums-with-define.patch
Patch9: 0009-libparted-Fix-handling-of-gpt-partition-types.patch
Patch10: 0010-tests-Add-a-libparted-test-for-ped_partition_set_sys.patch
Patch11: 0011-libparted-Fix-handling-of-msdos-partition-types.patch
Patch12: 0012-tests-Add-a-libparted-test-for-ped_partition_set_sys.patch
Patch13: 0013-parted-Add-display-of-GPT-UUIDs-in-JSON-output.patch
Patch14: 0014-gpt-Add-no_automount-partition-flag.patch

BuildRequires: gcc autoconf automake make
BuildRequires: e2fsprogs-devel readline-devel ncurses-devel gettext-devel libuuid-devel
BuildRequires: device-mapper-devel libblkid-devel >= 2.17
BuildRequires: gnupg2 git libtool e2fsprogs xfsprogs dosfstools texinfo
BuildRequires: perl-Digest-CRC bc python3 gperf

Provides: bundled(gnulib)

%description
GNU Parted manipulates partition tables. This is useful for creating space
for new operating systems, reorganizing disk usage, copying data on hard disks
and disk imaging. The package contains a library, libparted, as well as a
command-line frontend, parted, which can also be used in scripts.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%package devel
Summary:  Files for developing apps which will manipulate disk partitions
Requires: %{name} = %{EVR}
Requires: pkgconfig

%description devel
This package contains develop tools for manipulating disk partitions
and filesystems using the routines provided by the GNU Parted library.

%prep
%autosetup -p1
# Convert encoding of AUTHORS file from ISO-8859-1 to UTF8.
iconv -f ISO-8859-1 -t UTF8 AUTHORS > tmp && touch -r AUTHORS tmp && mv tmp AUTHORS

%build
autoreconf -fiv

CFLAGS="${RPM_OPT_FLAGS} -Wno-unused-but-set-variable"; export CFLAGS
%configure --disable-static --disable-gcc-warnings
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
%make_build

%install
%make_install

rm -f %{buildroot}%{_libdir}/*.la
rm -f %{buildroot}%{_infodir}/dir
rm -f %{buildroot}%{_bindir}/{label,disk}

%generate_compatibility_deps

%find_lang %{name}

%check
LD_LIBRARY_PATH=$(pwd)/libparted/.libs:$(pwd)/libparted/fs/.libs make check

%files -f %{name}.lang
%{_sbindir}/parted
%{_sbindir}/partprobe
%{_libdir}/libparted.so.2
%{_libdir}/libparted.so.2.0.4
%{_libdir}/libparted-fs-resize.so.0
%{_libdir}/libparted-fs-resize.so.0.0.4
%{_infodir}/parted.info.*

%dir %{abidir}
%{abidir}/libparted.dump
%{abidir}/libparted-fs-resize.dump
%{abidir}/parted-option.list
%{abidir}/partprobe-option.list

%{_mandir}/man8/parted.8.*
%{_mandir}/man8/partprobe.8.*
%license COPYING

%files doc
%doc README AUTHORS THANKS BUGS ABOUT-NLS NEWS

%files devel
%doc doc/API TODO doc/FAT
%{_libdir}/libparted.so
%{_libdir}/libparted-fs-resize.so
%{_libdir}/pkgconfig/libparted.pc
%{_libdir}/pkgconfig/libparted-fs-resize.pc
%{_includedir}/parted

%changelog
* Tue Apr 11 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 3.5-3
- Refactor the specfile

* Wed Dec 28 2022 Jing Zhang <renyu.zj@linux.alibaba.com> - 3.5-2
- Fix some bugs and add features:
- Fix handling of gpt partition types
- Fix handling of msdos partition types
- Add a libparted test for ped_partition_set_system on msdos
- Add display of GPT UUIDs in JSON output
- Add no_automount flag support
- increase xfs size to 300M etc.

* Fri Sep 23 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 3.5-1
- update to 3.5

* Fri Mar 04 2022 Hongwei Qin <qhw01063182@alibaba-inc.com> - 3.4-1
- New stable upstream release v3.4
- Init for Anolis OS 23
